#IFNDEF CONVNUMBASE_INC

#DEFINE CONVNUMBASE_INC

;ALL BASES CONVERSION
;but SPASM doesn't like some bases

#macro zconvnumbase(num,base)
#if num_remain == 0
 #if base==2
  #define baseprefix  "%"
 #endif
 #if base==10
  #define baseprefix  ""
 #endif
 #if base==16
  #define baseprefix  "$"
 #endif

 #ifdef baseprefix
  baseprefix,return
 #else
  return," base ",base
 #endif

#else
 #define num_digit eval(num & (base-1))
 #define num_remain eval(num / base)
 #ifndef return
   #define return ""
 #endif
    #if num_digit == 0
      #define num_char "0"
    #endif
    #if num_digit == 1
      #define num_char "1"
    #endif
    #if num_digit == 2
      #define num_char "2"
    #endif
    #if num_digit == 3
      #define num_char "3"
    #endif
    #if num_digit == 4
      #define num_char "4"
    #endif
    #if num_digit == 5
      #define num_char "5"
    #endif
    #if num_digit == 6
      #define num_char "6"
    #endif
    #if num_digit == 7
      #define num_char "7"
    #endif
    #if num_digit == 8
      #define num_char "8"
    #endif
    #if num_digit == 9
      #define num_char "9"
    #endif
    #if num_digit == 10
      #define num_char "A"
    #endif
    #if num_digit == 11
      #define num_char "B"
    #endif
    #if num_digit == 12
      #define num_char "C"
    #endif
    #if num_digit == 13
      #define num_char "D"
    #endif
    #if num_digit == 14
      #define num_char "E"
    #endif
    #if num_digit == 15
      #define num_char "F"
    #endif
 
 #define return eval(num_char,return)
 zconvnumbase(eval(num_remain),base)
#endif
#endmacro

;wrap the main macro up with another macro to clear the global defines to work more times
#macro convnumbase(znum,zbase)
  #define num_remain -1
  #define return ""
  #define baseprefix ""
  zconvnumbase(znum,zbase)
#endmacro

;Example usage:
; .echo convbas($80,10)

;Danger:
; .echo convdec(1000000000000)

#ENDIF