;;;;;;;;;;;;;;;;;;
;Debugging Macros;
;;;;;;;;;;;;;;;;;;

;Breakpoints
;-----------
#define	STOP		jp $		;danger: use only on emulator
#define	STOPEMU		jp $		;danger: use only on emulator
#define	STOPIFD		#ifdef DEBUG \ jp $ \ #endif
#define	PAUSE		b_call(_GetKey) \ ret

;Checks
;------
#define iy_use_save() push iy
#define iy_use_exit() pop iy

#define sp_save() ld (saveSP),sp
#define sp_exit() ld sp,(saveSP) \ pop iy \ ret \ saveSP: \ .dw $0000

#macro CheckPgrmRamLimit()
 #if $>$A000
  .echo "Warning! Code passed RAM limit in programs. Use rellocation."
 #else
  .echo "Program RAM limit OK."
 #endif
#endmacro
