
;Variable allocation macro to SPASM assembler
;by Galandros

;Example usage:
; varloc(tempswaparea)
;player_x = var(1)
;player_y = var(1)
;buffer_bullets = var(128)
;saveSP = var(2)
; varloc(textshadow)
;attack = var(1)
;deffence = var(1)

#macro var(var.size)
 #define var.counter eval(var.counter+var.inc)
 #define var.inc eval(var.size)
 #ifdef var.end
   #if var.counter>var.end
    .error "Variable allocation overflow!"
   #endif
 #endif
 var.counter
#endmacro

;alternate var macro name defining
#define varalloc var
#define Malloc var

#macro varloc(varloc.value,varloc.size)
 #define var.counter eval(varloc.value)
 #define var.inc 0
 #ifdef varloc.size
   #define var.end eval(varloc.value+varloc.size-1)
 #endif
#endmacro

;alternate var_loc macro name defining
#define var_loc varloc
#define vararea varloc


;Other:
#macro pgrm_ram_var(name,size)
name:
 .block size
#endmacro

;Alternative Method
;has to be before the .org directive
;can work in TASM
#define VAR(var.name,var.size)		var.name: \ .org var.name+(var.size)
#define LOC(loc.area)		.org loc.area
#define .Var  VAR(
#define .Loc  LOC(
